/*
 *  Source machine generated by GadToolsBox V2.0b
 *  which is (c) Copyright 1991-1993 Jaba Development
 *
 *  GUI Designed by : Michael D. Bayne
 */

#include <exec/types.h>
#include <intuition/intuition.h>
#include <intuition/classes.h>
#include <intuition/classusr.h>
#include <intuition/imageclass.h>
#include <intuition/gadgetclass.h>
#include <libraries/gadtools.h>
#include <graphics/displayinfo.h>
#include <graphics/gfxbase.h>
#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>
#include <clib/graphics_protos.h>
#include <clib/utility_protos.h>
#include <string.h>
#include <clib/diskfont_protos.h>

#include "Fade.h"

struct Screen         *Scr = NULL;
UBYTE                 *PubScreenName = NULL;
APTR                   VisualInfo = NULL;
struct Window         *FadeWnd = NULL;
struct Gadget         *FadeGList = NULL;
struct IntuiMessage    FadeMsg;
struct Gadget         *FadeGadgets[4];
UWORD                  FadeLeft = 0;
UWORD                  FadeTop = 12;
UWORD                  FadeWidth = 237;
UWORD                  FadeHeight = 28;
UBYTE                 *FadeWdt = (UBYTE *)"Fade Prefs";
struct TextAttr       *Font, Attr;
UWORD                  FontX, FontY;
UWORD                  OffX, OffY;
struct TextFont       *FadeFont = NULL;

UWORD FadeGTypes[] = {
	SLIDER_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND
};

struct NewGadget FadeNGad[] = {
	53, 2, 154, 10, (UBYTE *)"_Delay", NULL, GD_DELAY, PLACETEXT_LEFT, NULL, (APTR)DELAYClicked,
	9, 14, 66, 12, (UBYTE *)"_Ok", NULL, GD_OK, PLACETEXT_IN, NULL, (APTR)OKClicked,
	162, 14, 66, 12, (UBYTE *)"_Cancel", NULL, GD_CANCEL, PLACETEXT_IN, NULL, (APTR)CANCELClicked,
	85, 14, 66, 12, (UBYTE *)"_Test", NULL, GD_TEST, PLACETEXT_IN, NULL, (APTR)TESTClicked
};

ULONG FadeGTags[] = {
	(GTSL_Max), 59, (GTSL_Level), 15, (GTSL_MaxLevelLen), 4, (GTSL_LevelFormat), (ULONG)"%2ld", (GTSL_LevelPlace), (PLACETEXT_RIGHT), (PGA_Freedom), LORIENT_HORIZ, (GA_RelVerify), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE)
};

static UWORD ComputeX( UWORD value )
{
	return(( UWORD )((( FontX * value ) + 3 ) / 6 ));
}

static UWORD ComputeY( UWORD value )
{
	return(( UWORD )((( FontY * value ) + 4 ) / 8 ));
}

static void ComputeFont( UWORD width, UWORD height )
{
	Forbid();
	Font = &Attr;
	Font->ta_Name = (STRPTR)GfxBase->DefaultFont->tf_Message.mn_Node.ln_Name;
	Font->ta_YSize = FontY = GfxBase->DefaultFont->tf_YSize;
	FontX = GfxBase->DefaultFont->tf_XSize;
	Permit();

	OffX = Scr->WBorLeft;
	OffY = Scr->RastPort.TxHeight + Scr->WBorTop + 1;

	if ( width && height ) {
		if (( ComputeX( width ) + OffX + Scr->WBorRight ) > Scr->Width )
			goto UseTopaz;
		if (( ComputeY( height ) + OffY + Scr->WBorBottom ) > Scr->Height )
			goto UseTopaz;
	}
	return;

UseTopaz:
	Font->ta_Name = (STRPTR)"topaz.font";
	FontX = FontY = Font->ta_YSize = 8;
}

int SetupScreen( void )
{
	if ( ! ( Scr = LockPubScreen( PubScreenName )))
		return( 1L );

	ComputeFont( 0, 0 );

	if ( ! ( VisualInfo = GetVisualInfo( Scr, TAG_DONE )))
		return( 2L );

	return( 0L );
}

void CloseDownScreen( void )
{
	if ( VisualInfo ) {
		FreeVisualInfo( VisualInfo );
		VisualInfo = NULL;
	}

	if ( Scr        ) {
		UnlockPubScreen( NULL, Scr );
		Scr = NULL;
	}
}

int HandleFadeIDCMP( void )
{
	struct IntuiMessage	*m;
	int			(*func)();
	BOOL			running = TRUE;

	while( m = GT_GetIMsg( FadeWnd->UserPort )) {

		CopyMem(( char * )m, ( char * )&FadeMsg, (long)sizeof( struct IntuiMessage ));

		GT_ReplyIMsg( m );

		switch ( FadeMsg.Class ) {

			case	IDCMP_REFRESHWINDOW:
				GT_BeginRefresh( FadeWnd );
				GT_EndRefresh( FadeWnd, TRUE );
				break;

			case	IDCMP_VANILLAKEY:
				running = FadeVanillaKey();
				break;

			case	IDCMP_GADGETUP:
			case	IDCMP_GADGETDOWN:
				func = ( void * )(( struct Gadget * )FadeMsg.IAddress )->UserData;
				running = func();
				break;
		}
	}
	return( running );
}

int OpenFadeWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = FadeLeft, wtop = FadeTop, ww, wh;

	ComputeFont( FadeWidth, FadeHeight );

	ww = ComputeX( FadeWidth );
	wh = ComputeY( FadeHeight );

	wleft = ( Scr->Width - ww )/2 - Scr->WBorRight;
	wtop = ( Scr->Height - wh - Scr->WBorBottom*2 - Font->ta_YSize )/2;

	if ( ! ( FadeFont = OpenDiskFont( Font )))
		return( 5L );

	if ( ! ( g = CreateContext( &FadeGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < Fade_CNT; lc++ ) {

		CopyMem((char * )&FadeNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr   = Font;
		ng.ng_LeftEdge   = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge    = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width      = ComputeX( ng.ng_Width );
		ng.ng_Height     = ComputeY( ng.ng_Height);

		FadeGadgets[ lc ] = g = CreateGadgetA((ULONG)FadeGTypes[ lc ], g, &ng, ( struct TagItem * )&FadeGTags[ tc ] );

		while( FadeGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( FadeWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top,		wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	SLIDERIDCMP|BUTTONIDCMP|IDCMP_VANILLAKEY|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_SMART_REFRESH|WFLG_ACTIVATE|WFLG_RMBTRAP,
				WA_Gadgets,	FadeGList,
				WA_Title,	FadeWdt,
				WA_ScreenTitle,	"Fade Prefs",
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( FadeWnd, NULL );

	return( 0L );
}

void CloseFadeWindow( void )
{
	if ( FadeWnd        ) {
		CloseWindow( FadeWnd );
		FadeWnd = NULL;
	}

	if ( FadeGList      ) {
		FreeGadgets( FadeGList );
		FadeGList = NULL;
	}

	if ( FadeFont ) {
		CloseFont( FadeFont );
		FadeFont = NULL;
	}
}

