#ifndef CLIB_MATRIX_PROTOS_H
#define CLIB_MATRIX_PROTOS_H
/*
**      $Filename: clib/matrix_protos.h $
**      $Release: 1.3 $
**      $Revision: 39.1 $
**
**      C prototypes.
**
**      (C) Copyright 1993 Geert Uytterhoeven
**      All Rights Reserved
*/


BOOL	MX_MakePath( STRPTR name );

ULONG	MX_AddNodeSorted( struct List *l, struct Node *n );
ULONG	MX_WindowHandler2(struct Window *w, struct Screen *sc, struct TagItem *tags, APTR VisInfo);
void	MX_WindowHandler(struct Window *w, struct Screen *sc, struct TagItem *tags, APTR VisInfo);
struct NewMenu *MX_MakeMenu_Localize(struct NewMenu *nm, struct Catalog *c, APTR catCompArr, APTR tags);

STRPTR	MX_GetCatalogStr(struct Catalog *catalog, ULONG *catcomparr, ULONG id);

void	MX_CloseWinSafe(struct Window *win);
APTR	MX_DeCompressTrue(APTR buffer);

void	MX_RemakeGadgets(struct Window *win, struct Gadget *gad);

ULONG	MX_SendArexxString( STRPTR string, STRPTR portname, struct msgPort *replyPort);
void	MX_ShowWindow(struct Window *w, struct Task *t);
ULONG	MX_NewSortList(struct List *list, APTR hook, APTR tags, ULONG elements, ULONG data);
void	MX_SortList(struct List *list);
APTR	MX_LockWindow(struct Window *w);
void	MX_UnlockWindow(struct Window *w, APTR lock);
ULONG	MX_FileRequest2( STRPTR filenme, STRPTR title, APTR tags, APTR mxai, APTR aslreq, struct Window *w, ULONG len);
void	MX_FreeFIB(struct FileInfoBlock *fib);
struct	FileInfoBlock *MX_LoadFIB(ULONG type, ULONG typedata);
void	MX_ProcessArexxPort(struct MsgPort *mp, APTR table, ULONG userdata);
struct	MsgPort *MX_AddArexxPort( STRPTR name, APTR hook, ULONG data);
void	MX_RemArexxPort( struct MsgPort *port, APTR hook, ULONG data);

ULONG	MX_NewSaveIFF( STRPTR filename, APTR tags);
ULONG	MX_NewSaveIFFTags( STRPTR filename, unsigned long tag1Type, ... );
ULONG	MX_NewLoadIFF( STRPTR filename, APTR tags);
ULONG	MX_NewLoadIFFTags( STRPTR filename, unsigned long tag1Type, ... );

BPTR	MX_OpenPathNew( STRPTR name);
APTR	MX_CompressTrue( APTR buffer, ULONG length);
ULONG	MX_HexStrLong( STRPTR string);
LONG	MX_ExamineDir( APTR hook, LONG data, BPTR lock);
ULONG	MX_StrLen( APTR string);
BOOL	MX_PatternMatch( STRPTR string, STRPTR pattern );
ULONG	MX_TextFileToList( struct List *list, STRPTR filename, struct TagItem *tags );
ULONG	MX_TextFileToListTags( struct List *list, STRPTR filename, unsigned long tag1Type, ... );

ULONG	MX_CurrentTime( void );
void	MX_SoundID( STRPTR basename, STRPTR name);

APTR	MX_AllocVecStr( STRPTR string, ULONG attrs);

APTR	MX_AddVBlankNode( APTR tags);
APTR	MX_AddVBlankNodeTags( unsigned long tag1Type, ... );
void	MX_RemVBlankNode( APTR vbn);

ULONG	MX_DisplayRequest( STRPTR body, STRPTR buttons, APTR data);
ULONG	MX_DisplayRequestWin( STRPTR body, STRPTR buttons, APTR data, struct Window *win);
LONG	MX_RandomInRange( LONG min, LONG max );

/*
APTR	MX_ReplaceVecStr( STRPTR string, APTR handle, ULONG attributes);
*/

STRPTR	MX_ReplaceVecStr( STRPTR string, APTR handle, ULONG attributes);

void	MX_FreeFont(struct TextAttr *textattr , APTR font, struct TagItem *tagList );
void	MX_FreeFontTags(struct TextAttr *textattr , APTR font, unsigned long tag1Type, ... );
APTR	MX_GetFontTags( struct TextAttr *textattr, unsigned long tag1Type, ... );
APTR	MX_GetFont( struct TextAttr *textattr, struct TagItem *tagList );

ULONG	MX_FontWidth( struct TextAttr *textattr);

void	MX_FreeArgs( APTR MxArgLock);
APTR	MX_ReadArgs( STRPTR template, APTR array, APTR wbmsg);
APTR	MX_NewReadArgs( STRPTR template, APTR array, struct TagItem *tags);
void	MX_StrCpyLen( STRPTR source, STRPTR dest, LONG len);
void	MX_SoundID( STRPTR basename, STRPTR name);
ULONG	MX_NewLoadIFF( STRPTR filename, struct TagItem *tags);
ULONG	MX_NewPrefsWH( struct TagItem *tags);
ULONG	MX_NewPrefsWHTags( unsigned long tag1Type, ... );
APTR	MX_RawFormat( STRPTR format, APTR data , APTR dest);
int	MX_Random(int range);
void	MX_FreeListNodes(struct List *list, APTR *hook, LONG userdata);

struct	MxNameInfo *MX_AddNameInfoTagList( STRPTR, struct TagItem *);
struct	MxNameInfo *MX_AddNameInfoTags( STRPTR, unsigned long tag1Type, ... );
void	MX_RemNameInfo( struct MxNameInfo *);
struct	MxNameInfo *MX_FindNameInfo( STRPTR );

BOOL	MX_SetConfigTags( unsigned long tag1Type, ... );
BOOL	MX_GetConfigTags( unsigned long tag1Type, ... );

BOOL	MX_Log( STRPTR, STRPTR, ULONG, ULONG );

void	MX_UpdateGadgetsTagList( struct Gadget *gadget, struct TagItem *tags );
void	MX_UpdateGadgetsTags( struct Gadget *gadget, unsigned long tag1Type, ... );

struct Hook *MX_InitHook( struct Hook *, APTR, ULONG );

LONG MX_ScreenModeInfoFromName( struct MXScreenMode *, STRPTR );
LONG MX_ScreenModeNameTagList( STRPTR, struct MXScreenMode *, struct TagItem *);
LONG MX_ScreenModeNameTags( STRPTR, struct MXScreenMode *, unsigned long tag1Type, ... );

LONG	MX_GetScreenNameTagList( struct MXScreenMode *, STRPTR, struct TagItem *);
LONG	MX_GetScreenNameTags( struct MXScreenMode *, STRPTR, unsigned long tag1Type, ... );

LONG	MX_GetScreenInfo( struct MXScreenMode *, STRPTR );

void	MX_Test( void );

#endif  /* CLIB_MATRIX_PROTOS_H */
